=== debian/changelog ===
magics++ (2.34.3-2) unstable; urgency=medium

  * Drop B-D on transitional libhdf5-serial-dev. Closes: #879142 

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 20 Oct 2017 10:44:25 +0100

magics++ (2.34.3-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.1.1

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 03 Oct 2017 13:38:33 +0100
